#include <stdio.h>
#include <math.h>
#include "proj.h"
#include "allocate.h"


#define swap(a,b) dtemp=a;a=b;b=dtemp

int axis(int l, int k, float C[4][2]);



float proj(int i, int j, int a, int t, float dim[4][2])
{
	float C[4][2];
	int l,k,m1,m2,diff;
	static int first = 1;
	static float dN,dM,dT,area,*cosv,*sinv;
	static int N,M,A,T;

	float t1,t2, theta, cost, sint, PC[4];
	float dtemp ;
	 

	if (first)
	{
		first = 0;
		N = dim[0][0];
		dN = dim[0][1];
		M = dim[1][0];
		dM = dim[1][1];
		A = dim[2][0];
		T = dim[3][0];
		dT = dim[3][1];
		area = dN*dM;

		cosv = (float *)get_vector(A, sizeof(float));
		sinv = (float *)get_vector(A, sizeof(float));

		for(a=0;a<A;a++)
		{
			theta = a*M_PI/A;
			cosv[a] = cos(theta);
			sinv[a] = sin(theta);
		}
	}


	/* Calculate the corners of the square */

	C[0][0] = (-M/2.0 + j)*dM;
	C[0][1] = (N/2.0 - i)*dN;
	C[1][0] = C[0][0];
	C[1][1] = C[0][1] - dN;
	C[2][0] = C[0][0] + dM;
	C[2][1] = C[0][1];
	C[3][0] = C[0][0] + dM;
	C[3][1] = C[0][1] - dN;

	/* Calculate angle and position of stip */

	t1 = (-T/2.0 + t)*dT;
	t2 = t1 + dT;

	/* Calculate the projections of the corners on the line */

	cost = cosv[a];
	sint = sinv[a];
	for(l=0;l<4;l++)
		PC[l] = C[l][0]*cost + C[l][1]*sint;


	/* Sort the Projections and Corners */

	for(l=0;l<3;l++)
		for(k=l+1;k<4;k++)
			if( PC[l] > PC[k] )
			{
				swap(PC[l],PC[k]);
				swap(C[l][0], C[k][0]);
				swap(C[l][1], C[k][1]);

			}

	/* Mark the position of the strip wrt the corners */

	if ( t1 >= PC[3] )
		m1 = 4;
	else
		for(l=0;l<4;l++)
			if(t1 <= PC[l])
			{
				m1 = l;
				break;
			}

	if ( t2 >= PC[3] )
		m2 = 4;
	else
		for(l=0;l<4;l++)
			if(t2 <= PC[l])
			{
				m2 = l;
				break;
			}
	
	diff = m2 - m1;


	cost = fabs(cost);
	sint = fabs(sint);
	switch(diff)
	{
	
		case 0:
				switch( m1)
				{
					case 0: return(0.0);

					case 1: 
							dtemp = sint/cost;
							dtemp = (dtemp + 1/dtemp)/2.0;
							dtemp = dT*dT*dtemp 
									+ (t1-PC[0])*dT/(sint *cost);
							return(dtemp);

					case 2:
							if(axis(2,3,C))
								return (dN*dT/cost) ;
							else
								return (dM*dT/sint) ;
							
					case 3:
							dtemp = sint/cost;
							dtemp = (dtemp + 1/dtemp)/2.0;
							dtemp = dT*dT*dtemp 
									+ (PC[3]-t2)*dT/(sint *cost);
							return(dtemp);

					case 4: return(0.0);
					
				}

		case 1:
				switch( m1)
				{
					case 0:
							dtemp = (t2 - PC[0]);
							return( dtemp*dtemp/(2.0*sint *cost));
					case 1:
							dtemp = (t1 - PC[0]);
							dtemp =  dtemp*dtemp/(2.0*sint*cost);
							if(axis(2,3,C))
								dtemp = dtemp + (PC[2] - t2)*dN/cost
								        + dN*dN*sint/(cost*2.0);
							else
								dtemp = dtemp + (PC[2]-t2)*dM/sint
										+ dM*dM*cost/(sint*2.0) ;

							return(area - dtemp);

					case 2:
							dtemp = (PC[3]- t2);
							dtemp =  dtemp*dtemp/(2.0*sint*cost);
							if(axis(0,1,C))
								dtemp = dtemp + (t1-PC[1])*dN/cost
										+ dN*dN*sint/(cost*2.0);
							else
								dtemp = dtemp + (t1-PC[1])*dM/sint 
										+ dM*dM*cost/(cost*2.0);

							return(area - dtemp);

					case 3:
							dtemp = (PC[3] - t1);
							return( dtemp*dtemp/(2.0*sint*cost));

				}

		case 2:
				switch( m1)
				{
					case 0:
							if(axis(2,3,C))
								dtemp = (PC[2]-t2)*dN/cost 
										+ dN*dN*sint/(cost*2.0);
							else
								dtemp = (PC[2]-t2)*dM/sint
										+ dM*dM*cost/(sint*2.0);

							return(area - dtemp);
							
					case 1:	
							dtemp = (t1 - PC[0])*(t1 - PC[0]);
							dtemp = dtemp + (PC[3]- t2)*(PC[3]- t2);
							dtemp =  dtemp/(2.0*sint*cost);

							return(area - dtemp);

					case 2:
							if(axis(0,1,C))
								dtemp =  (t1 - PC[1])*dN/cost 
										 + dN*dN*sint/(cost*2.0);
							else
								dtemp = (t1-PC[1])*dM/sint 
										+ dM*dM*cost/(sint*2.0);

							return(area - dtemp);

				}
				

		case 3:
				switch( m1)
				{
					case 0:
							dtemp = (PC[3]- t2);
							dtemp =  dtemp*dtemp/(2.0*sint*cost);
							return(area - dtemp);

					case 1:
							dtemp = (t1 - PC[0]);
							dtemp =  dtemp*dtemp/(2.0*sint*cost);
							return(area - dtemp);
				}


					
							
		case 4: return( area );
	}

}


int axis(int l, int k, float C[4][2])
{
	if(C[l][0] == C[k][0])
		return(1);
	else
		return(0);
}




void range(int i, int j, int a, int *start, int *stop, float dim[4][2])
{
	float C[4][2];
    static int first = 1;
	static float dN,dM,dT;
	static int N,M,A,T;
	int l;
	float sint,cost,theta,min,max,PC[4],temp;


	if (first)
	{
		first = 0;
		N = dim[0][0];
		dN = dim[0][1];
		M = dim[1][0];
		dM = dim[1][1];
		A = dim[2][0];
		T = dim[3][0];
		dT = dim[3][1];
	}


	C[0][0] = (-M/2.0 + j)*dM;
	C[0][1] = (N/2.0 - i)*dN;
	C[1][0] = C[0][0];
	C[1][1] = C[0][1] - dN;
	C[2][0] = C[0][0] + dM;
	C[2][1] = C[0][1];
	C[3][0] = C[0][0] + dM;
	C[3][1] = C[0][1] - dN;

	theta = a*M_PI/A;

	cost = cos(theta);
	sint = sin(theta);
	for(l=0;l<4;l++)
		PC[l] = C[l][0]*cost + C[l][1]*sint;

	min = PC[0];
	max = PC[0];
	for(l=1;l<4;l++)
	{
		if (min > PC[l])
			min = PC[l];
		else if (max < PC[l])
			max = PC[l];
	}


	temp=(min+T*dT/2.0)/dT;
	*start = temp;
	if (temp - *start > 0.99999)
		*start = *start + 1;

	temp = (max + T*dT/2.0)/dT;
	*stop = temp;
	if (temp - *stop < 0.0001)
		*stop = *stop - 1;

	if (*start < 0)
		*start = 0;
	if (*stop >= T)
		*stop = T-1;


}

void f_project(float **X, float **Y, struct prj_matrix ***prj, float dim[4][2])
{
	int i,j,a,t,l;

	for(a=0;a<dim[2][0];a++)
		for(t=0;t<dim[3][0];t++)
			Y[a][t] = 0.0;

    for(i=0;i<dim[0][0];i++)
		for(j=0;j<dim[1][0];j++)
			for(a=0;a<dim[2][0];a++)
				for(t=prj[i][j][a].start,l=0;t<=prj[i][j][a].stop;t++,l++)
					Y[a][t] = Y[a][t] + prj[i][j][a].p[l]*X[i][j];
}

void b_project(float **X, float **Y, struct prj_matrix ***prj, float dim[4][2])
{
	int i,j,a,t,l;


	for(i=0;i<dim[0][0];i++)
		for(j=0;j<dim[1][0];j++)
		{
			X[i][j] = 0.0;
			for(a=0;a<dim[2][0];a++)
				for(t=prj[i][j][a].start,l=0;t<=prj[i][j][a].stop;t++,l++)
					X[i][j] = X[i][j] + prj[i][j][a].p[l]*Y[a][t];

			if (X[i][j] < 0.0)
				X[i][j] = 0.0;
			else
				X[i][j] = X[i][j]*M_PI/dim[2][0];
		}

}



void make_prj_matrix( struct prj_matrix ***prj, float dim[4][2])
{
	int i,j,a,t,k,start,stop,num;

	for(i=0;i<dim[0][0];i++)
		for(j=0;j<dim[1][0];j++)
			for(a=0;a<dim[2][0];a++)
			{
				range(i,j,a,&start,&stop,dim);
				prj[i][j][a].start = start;
				prj[i][j][a].stop = stop;
				num = stop - start + 1;
				if (num > 0)
				{
					prj[i][j][a].p = (float *)get_vector(num,sizeof(float));
					for(t=start,k=0;t<=stop;t++,k++)
						prj[i][j][a].p[k] = proj(i,j,a,t,dim);
					
				}
			}	
}
